#define UserInfoFile "userinfo.txt"
#define ScheduleInfoFile "schedule.txt"
#include<stdio.h>
#include<string.h> 
#include<stdlib.h> 
struct userInfo
{
	unsigned int userId;
	char userName[20];
};
struct scheduleDate
{
	unsigned int year;
	unsigned int month;
	unsigned int day;
};
struct schedule
{
	unsigned int sid;
	struct userInfo userinfo;
	struct scheduleDate sdate;
	char smemo[200];
};

void printMenu(void) 
 {
	printf("*********************************\n"); 
	printf("\tճ̹ܲ˵\t\n");                                                              
	printf("*********************************\n"); 
	printf("0˳\n"); 
	printf("1ûע\n");  
	printf("2û¼\n");
	printf("3ճ̣ճ̷\n");
	printf("4ճ޸\n");
	printf("5ճɾ\n");
	printf("6ճ̲ѯ\n");
	printf("7ճ\n");
	printf("8ճ̵\n");
	printf("*********************************\n"); 
	printf("  \n");
} 

int openFile(FILE **fp,char openMode, char *filename)//޸˺ԭ
{
	switch(openMode)
	{
		case 'r':
			*fp=fopen(filename,"r");
			if( (fp== NULL) ){
				printf("can't open file...");
			    exit(0); 
			}
			else return 1;
		case 'w':
			*fp=fopen(filename,"r+");
			if( (fp== NULL)) {
				printf("can't open file...");
			    exit(0); 
			}
			else return 1;
		case 'a':
			*fp=fopen(filename,"a+");
			if( (fp== NULL)) {
				printf("can't open file...");
			    exit(0); 
			}
			else return 1;
	}
}

int closeFile(FILE **fp)
{
	if(fclose(*fp)==0)
		return 1;
	else
		return 0;
}

int userReg(struct userInfo ui,FILE *fp)
{
	struct userInfo tempui;
	int flag=0;
	while(1){
		if(fscanf(fp,"%u %s",&tempui.userId,tempui.userName)==EOF)
			break;
		if(tempui.userId==ui.userId){
			flag=1;
			break;
		}
	}
	if(flag)
		return 0;
	else{
		fprintf(fp,"%u %s\n",ui.userId,ui.userName);
		return 1;
	}   
 } 
 
int userLogin(char *username,FILE *fp)//ԭĿĺԭдûֻһַĳַ
{
	struct userInfo tempui;
	int flag=0;
	while(1){
		if(fscanf(fp,"%u %s",&tempui.userId,tempui.userName)==EOF)
			break;
		if(strcmp(tempui.userName,username)==0){
			flag=1;
			break;
		}
	}
	return flag;
 } 
 
int createSchedule(struct userInfo ui,struct scheduleDate sd,FILE *fp)//βѾṩûϢڣֱдļ
{
	char neirong[200];	
	struct schedule temp;
	unsigned int sid=0;
	int flag=0;		
	while(1){
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp.sid,&temp.userinfo.userId,temp.userinfo.userName,&temp.sdate.year,&temp.sdate.month,&temp.sdate.day,temp.smemo)==EOF)
			break;
		if(temp.sid>sid)
			sid=temp.sid;
	}
	sid++;
	printf("ճݣ");
	scanf("%s",neirong);
	fprintf(fp,"%u %u %s %u %u %u %s\n",sid,ui.userId,ui.userName,sd.year,sd.month,sd.day,neirong);
	flag=1;
	printf("sid%u",sid); 
	return flag;
}

int modifySchedule(unsigned int sid,FILE *fp)//ȫȻ޸ģȫдļ
{
	struct schedule temp[100];//100
	int i,n=0,flag=0;
	while(1){//ȫṹ
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp[n].sid,&temp[n].userinfo.userId,temp[n].userinfo.userName,&temp[n].sdate.year,&temp[n].sdate.month,&temp[n].sdate.day,temp[n].smemo)==EOF)
			break;
		n++;
	}
	for(i=0;i<n;i++)//
		if(temp[i].sid==sid){
			flag=1;
			break;
		}
	if(flag){
		printf("޸ĵճݣ");
		scanf("%s",temp[i].smemo);
		fclose(fp);
		fp=fopen(ScheduleInfoFile,"w");
		for(i=0;i<n;i++){
			fprintf(fp,"%u %u %s %u %u %u %s\n",temp[i].sid,temp[i].userinfo.userId,temp[i].userinfo.userName,temp[i].sdate.year,temp[i].sdate.month,temp[i].sdate.day,temp[i].smemo);
		}
		fclose(fp);
		
	}
	return flag;
}

int deleteSchedule(unsigned int sid,FILE *fp)//ȫȫдȥҪɾǸsid
{
	struct schedule temp[100];//100
	int i,j,n=0,flag=0;
	while(1){
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp[n].sid,&temp[n].userinfo.userId,temp[n].userinfo.userName,&temp[n].sdate.year,&temp[n].sdate.month,&temp[n].sdate.day,temp[n].smemo)==EOF)
			break;
		n++;
	}
	for(i=0;i<n;i++)
		if(temp[i].sid==sid){
			flag=1;
			break;
		}
	if(flag){
		fclose(fp);
		fp=fopen(ScheduleInfoFile,"w");
		for(j=0;j<n;j++){
			if(j==i)//Ŀsidдļ
				continue;
			fprintf(fp,"%u %u %s %u %u %u %s\n",temp[j].sid,temp[j].userinfo.userId,temp[j].userinfo.userName,temp[j].sdate.year,temp[j].sdate.month,temp[j].sdate.day,temp[j].smemo);
		}
		fclose(fp);
	}
	return flag;
}

struct schedule getsSscheduleInfo(unsigned int sid,FILE *fp)
{
	struct schedule temp;
	int flag=1;
	temp.sid==-1; 
	while(1){
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp.sid,&temp.userinfo.userId,temp.userinfo.userName,&temp.sdate.year,&temp.sdate.month,&temp.sdate.day,temp.smemo)==EOF)
			break;
		if(temp.sid==sid){	
			flag=0;		
			break;
		}
	}
	if(flag){
		printf("δҵ\n");
		return temp;
	}
	else
		return temp;
}

void sortSchedule(int sortField,int sortType,FILE *fp)//ȫȡṹ飬Ȼṹȫдļ
{
	struct schedule temp[100];//100
	struct schedule temp2;
	int n=0,n1=0;
	int i=0,j=0,k=0;
	
	while(1){
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp[n].sid,&temp[n].userinfo.userId,temp[n].userinfo.userName,&temp[n].sdate.year,&temp[n].sdate.month,&temp[n].sdate.day,temp[n].smemo)==EOF)
			break;
		n++;
	}
	n1=n;
	switch(sortField){
		case 1:
			for(i=0;i<n1-1;i++){			
					k=i;
		    		for(j=i+1;j<n1;j++)
		    			if(temp[k].sid>temp[j].sid)
		    				k=j;
					if(k!=i){
						temp2=temp[k];//ṹֱ֮Ӹֵ
						temp[k]=temp[i];
						temp[i]=temp2;
					}				
				}			
		    break;	   
		case 2:
			for(i=0;i<n1-1;i++){
					k=i;
		    		for(j=i+1;j<n1;j++)
		    			if(temp[k].userinfo.userId>temp[j].userinfo.userId)
		    				k=j;
					if(k!=i){
						temp2=temp[k];//ṹֱ֮Ӹֵ
						temp[k]=temp[i];
						temp[i]=temp2;
					}				
				}		
		    break;	   
	    case 3:
		    for(i=0;i<n1-1;i++){
		    	k=i;
		    	for(j=i+1;j<n1;j++)
		    		if((temp[k].sdate.year>temp[j].sdate.year)||((temp[k].sdate.year==temp[j].sdate.year)&&(temp[k].sdate.month>temp[j].sdate.month))||(((temp[k].sdate.year==temp[j].sdate.year)&&(temp[k].sdate.month==temp[j].sdate.month))&&(temp[k].sdate.day>temp[j].sdate.day)))
		    			k=j;						
				if(k!=i){
						temp2=temp[k];//ṹֱ֮Ӹֵ
						temp[k]=temp[i];
						temp[i]=temp2;
					}				
				}							
		    break;	
	}
	fclose(fp);
	fp=fopen(ScheduleInfoFile,"w");
	if(sortType==0)
		for(n=0;n<n1;n++)
			fprintf(fp,"%u %u %s %u %u %u %s\n",temp[n].sid,temp[n].userinfo.userId,temp[n].userinfo.userName,temp[n].sdate.year,temp[n].sdate.month,temp[n].sdate.day,temp[n].smemo);
	else if(sortType==1)
		for(n=n1-1;n>=0;n--)
			fprintf(fp,"%u %u %s %u %u %u %s\n",temp[n].sid,temp[n].userinfo.userId,temp[n].userinfo.userName,temp[n].sdate.year,temp[n].sdate.month,temp[n].sdate.day,temp[n].smemo);
	fclose(fp);
}

void printSchedule(int printType,FILE *fp)//ȫʾ
{
	int sortType;
	struct schedule temp;
	printf("뵼˳01\n");
	scanf("%d",&sortType);	
	sortSchedule(printType,sortType,fp);
	fclose(fp);
	fp=fopen(ScheduleInfoFile,"r");
	while(1){
		if(fscanf(fp,"%u %u %s %u %u %u %s",&temp.sid,&temp.userinfo.userId,temp.userinfo.userName,&temp.sdate.year,&temp.sdate.month,&temp.sdate.day,temp.smemo)==EOF)
			break;
		
		printf("%u %u %s %u %u %u %s\n",temp.sid,temp.userinfo.userId,temp.userinfo.userName,temp.sdate.year,temp.sdate.month,temp.sdate.day,temp.smemo);
	}
	fclose(fp);
}

int PanDuanRiQi(unsigned int y,unsigned int m,unsigned int d)
{
	int flag=1;
	if(y<0)
		flag=0;
	else if(m==0||m>12)
		flag=0;
	else if(d==0||d>31)
		flag=0;
	else if((m==4||m==6||m==9||m==11)&&d==31)
		flag=0;
	else if((y%400==0||((y%4==0)&&(y%100!=0)))&&m==2&&(d>29))
		flag=0;
	else if(!(y%400==0||((y%4==0)&&(y%100!=0)))&&m==2&&(d>28))
		flag=0;
	return flag;
} 

int main()
{
	char username[20];
	struct userInfo ui;
	struct scheduleDate sd;
	unsigned int sid;
	struct schedule temp_schedule;
	int ch,sortField, sortType, printType,userLoginStatus=0;	
	FILE *fp=NULL; 
	while(1)
	{
		printMenu();
		printf("ѡ˵ţ");
		scanf("%d",&ch);
        if(ch==0) break;
        switch(ch)
        {
        	case 1:
        		printf("userId,userName:\n");
				scanf("%u %s",&ui.userId,ui.userName);
        		openFile(&fp,'a',UserInfoFile);
        		if(userReg(ui,fp)) 
					printf("עɹ\n");
				else
					printf("עʧܣ\n"); 
				closeFile(&fp);
				break;
        	case 2:
			    printf("¼username\n");
				scanf("%s",&username);
				openFile(&fp,'r',UserInfoFile);
				if(userLogin(username,fp)){
					userLoginStatus=1;
					printf("¼ɹ\n");
				}					
				else
					printf("¼ʧܣ\n"); 
				closeFile(&fp);
				break;
			case 3:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("userId,userName:\n");
				scanf("%u %s",&ui.userId,ui.userName);
				printf("ճ:(  )\n");
				scanf("%u %u %u",&sd.year,&sd.month,&sd.day);
				if(!PanDuanRiQi(sd.year,sd.month,sd.day)) 
				{
					printf("date error!\n"); break;
				}
				else{
					openFile(&fp,'a',ScheduleInfoFile);
				    if(createSchedule(ui,sd,fp))
					    printf("ɹ\n");
				    else
				    	printf("ʧܣ\n"); 
				    closeFile(&fp);
				    break;
			    }				
			case 4:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("޸ĵճsid\n");
				scanf("%u",&sid);
				openFile(&fp,'w',ScheduleInfoFile);
				if(modifySchedule(sid,fp))
					printf("޸ĳɹ\n");
				else
					printf("޸ʧܣ\n"); 
				closeFile(&fp);	
				break;
			case 5:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("ɾճsid\n");
				scanf("%u",&sid);
				openFile(&fp,'w',ScheduleInfoFile);
				if(deleteSchedule(sid,fp))
					printf("ɾɹ\n");
				else
					printf("ɾʧܣ\n"); 
				closeFile(&fp);	
				break;
			case 6:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("ѯճsid\n");
				scanf("%u",&sid);
				openFile(&fp,'r',ScheduleInfoFile);
				temp_schedule=getsSscheduleInfo(sid,fp);
				if(temp_schedule.sid==sid)
					printf("%uճϢ£%u %u %s %u %u %u %s\n",sid,temp_schedule.sid,temp_schedule.userinfo.userId,temp_schedule.userinfo.userName,temp_schedule.sdate.year,temp_schedule.sdate.month,temp_schedule.sdate.day,temp_schedule.smemo); 
				closeFile(&fp);	
				break;
			case 7:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("ֶΣ1ţ2ûid3ճ\n");
				scanf("%d",&sortField);
				printf("ͣ01\n");
				scanf("%d",&sortType);
				openFile(&fp,'w',ScheduleInfoFile);
				sortSchedule(sortField,sortType,fp);
				closeFile(&fp);	
				break;
			case 8:
				if(!userLoginStatus){
					printf("ȵ¼");
					break;
				}
				printf("ӡͣ1ţ2ûid3ճ\n");
				scanf("%d",&printType);			
				openFile(&fp,'w',ScheduleInfoFile);
				printSchedule(printType,fp);
				closeFile(&fp);	
/*			default:
			    printf("!\n");
			    break; */
		}
	 } 
	 return 0;
 } 
